﻿using System;
using System.Activities;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Workflow;
 


namespace CustomActivityLibrary
{
    public class CustomAcitityLibrary : CodeActivity
    {
        [Input("My contact")]
        [ReferenceTarget("contact")]
        [Default("{575A8B41-F8D7-4DCE-B2EA-3FFDE936AB1B}", "contact")]
        public InArgument<EntityReference> inContact { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            // Get the tracing service
            ITracingService tracingService = context.GetExtension<ITracingService>();
            // Get the context service.
            IWorkflowContext mycontext = context.GetExtension<IWorkflowContext>();
            IOrganizationServiceFactory serviceFactory = context.GetExtension<IOrganizationServiceFactory>();
            // Use the context service to create an instance of CrmService.
            IOrganizationService crmService = serviceFactory.CreateOrganizationService(mycontext.UserId);
    
            //Get the Contact
            Contact myContact = new Contact();
            myContact.ContactId = inContact.Get(context).Id;


            // Creates the Phone Call activity for this conatct
            PhoneCall myPhoneCall =
                new PhoneCall();
            myPhoneCall.Subject = "Call this new contact";
            myPhoneCall.RegardingObjectId = new EntityReference(Contact.EntityLogicalName, (Guid) myContact.ContactId);
            crmService.Create(myPhoneCall);
            tracingService.Trace("PhoneCall created.");
        }
    }
}
